#include "../include/PlayState.h"

using namespace Ogre;

void PlayState::PlayMove(const FrameEvent& evt)
{
	Real MoveFactor = 500.0f * evt.timeSinceLastFrame;
	camPos = mCamera->getPosition();
	mInputDevice->capture();
	
	//Mousemovement
	mCamera->yaw(Degree(-mInputDevice->getMouseRelativeX() * 0.13));
        mCamera->pitch(Degree(-mInputDevice->getMouseRelativeY() * 0.13));

	//KB-input
    if(mInputDevice->isKeyDown(Ogre::KC_LSHIFT)||mInputDevice->isKeyDown(Ogre::KC_RSHIFT))
	MoveFactor+=3.0f;
    if(mInputDevice->isKeyDown(Ogre::KC_W))
        mCamera->moveRelative(Vector3(0.0f, 0.0f, -MoveFactor));
    if(mInputDevice->isKeyDown(Ogre::KC_S))
        mCamera->moveRelative(Vector3(0.0f, 0.0f, MoveFactor));
    if(mInputDevice->isKeyDown(Ogre::KC_A))
        mCamera->moveRelative(Vector3(-MoveFactor, 0.0f, 0.0f));
    if(mInputDevice->isKeyDown(Ogre::KC_D))
        mCamera->moveRelative(Vector3(MoveFactor, 0.0f, 0.0f));


	this->CameraSphere.setCenter (mCamera->getPosition());
	
	if (CameraSphere.intersects(TestSphere))
	{
		mCamera->setPosition(2500.0f, 100.0f, 2500.0f);		
	}
	if (!CameraSphere.intersects(TestAABox))
	{
		mCamera->setPosition(camPos);
	}
	if (CameraSphere.intersects(TestbuildingAABox))
	{
		mCamera->setPosition(camPos);
	}

     mRaySceneQueryCam = mSceneMgr->createRayQuery( Ray() );
     //mRaySceneQueryRobot = mSceneMgr->createRayQuery( Ray() );

		// Setup the scene query for the cam
        camPos = mCamera->getPosition();
        Ray cameraRay( Vector3(camPos.x, 8000.0f, camPos.z), Vector3::NEGATIVE_UNIT_Y );
        mRaySceneQueryCam->setRay( cameraRay );
	
		//Setup the scene query for the robot
	
	//robotPos = mNode->getPosition( );
       // Ray robotRay( Vector3(robotPos.x, 5000.0f, robotPos.z), Vector3::NEGATIVE_UNIT_Y );
        //mRaySceneQueryRobot->setRay( robotRay );
	
	

	        // Perform the scene query, first for cam,then for robot
        RaySceneQueryResult &camresult = mRaySceneQueryCam->execute();
        RaySceneQueryResult::iterator camitr = camresult.begin( );

	//RaySceneQueryResult &robotresult = mRaySceneQueryRobot->execute();
       // RaySceneQueryResult::iterator robotitr = robotresult.begin( );
	
	// Get the results, set the camera height
        if ( camitr != camresult.end() && camitr->worldFragment )
     {		
		
        Real terrainHeight = camitr->worldFragment->singleIntersection.y;
            if ((terrainHeight + 160.0f) > camPos.y||(terrainHeight + 160.0f) < camPos.y)
                mCamera->setPosition( camPos.x, terrainHeight + 160.0f, camPos.z );
     }

	// Get the results, set the robot height
       // if ( robotitr != robotresult.end() && robotitr->worldFragment )
     //{		
		
     //   Real terrainHeight = robotitr->worldFragment->singleIntersection.y;
      //      if ((terrainHeight + 40.0f) > robotPos.y)
      //          mNode->setPosition( robotPos.x, terrainHeight + 0.3f, robotPos.z );
    // }


}
