#include <OGRE/Ogre.h>
#include <OGRE/OgreKeyEvent.h>

#include "../include/PlayState.h"
#include "../include/IntroState.h"
#include "../include/PauseState.h"

using namespace Ogre;

PlayState PlayState::mPlayState;

void PlayState::enter()
{
	mInputDevice = InputManager::getSingletonPtr()->getInputDevice();
	mRoot = Root::getSingletonPtr();

	mSceneMgr = mRoot->getSceneManager(ST_EXTERIOR_CLOSE);
	mCamera = mSceneMgr->createCamera("PlayerCamera");
 	// Set camera look point
        mCamera->setPosition( 2500.0f, 100.0f, 2500.0f );
        //mCamera->pitch( Degree(-30) );
        mCamera->yaw( Degree(-110) );

	mCamera->setNearClipDistance(5);
	mViewport = mRoot->getAutoCreatedWindow()->addViewport(mCamera);
	mViewport->setBackgroundColour(ColourValue(0.0, 0.0, 0.0));

    //Test starts here
	
        
	this->PlaySetScene0();
	
}

void PlayState::exit()
{	
	ParticleSystemManager::getSingleton().destroySystem("Test");
	mSceneMgr->clearScene();
	this->testoverlay->hide();
        //!! Note: This is supposed to be mSceneMgr->destroyAllCameras(); for CVS head
	mSceneMgr->removeAllCameras();
	mRoot->getAutoCreatedWindow()->removeAllViewports();
	

}

void PlayState::pause()
{
	mSceneMgr->setSkyDome(true,"Skydome/pause", 5, 8);
	this->testoverlay->hide();
}

void PlayState::resume()
{
	mViewport->setBackgroundColour(ColourValue(0.0, 0.0, 0.0));
	mSceneMgr->setSkyDome(true, "Skydome/test", 5, 8);
	this->testoverlay->show();
}

void PlayState::keyClicked(KeyEvent* e)
{
}

void PlayState::keyPressed(KeyEvent* e)
{
	if (e->getKey() == KC_P)
	{
		pushState(PauseState::getInstance());
	}

	
	//if (e->getKey() == KC_B)
	//{
	 //	mEntity = mSceneMgr->createEntity( "NewCube", "Cube.mesh" );
	//	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "NewCubeNode", Vector3( mCamera->getPosition()) );
	//	mNode->attachObject( mEntity );
	//	mNode->	setScale (70.0f, 70.0f, 70.0f);
	//	StatGeom->addSceneNode(mNode);
		
	//}
	
	
	if (e->getKey() == KC_ESCAPE)
	{
		changeState(IntroState::getInstance());
	}
}

void PlayState::keyReleased(KeyEvent* e)
{
}

bool PlayState::frameStarted(const FrameEvent& evt)
{
	
	this->PlayMove(evt);
   // if(mInputDevice->isKeyDown(Ogre::KC_R))
	//{
	//mAnimationState = mEntity->getAnimationState( "Walk" );
        //mAnimationState->setLoop( true );
        //mAnimationState->setEnabled( true );
	
        //if(mInputDevice->isKeyDown(Ogre::KC_UP))
        //	{
	//	mNode->translate(0.0, 0.0, -MoveFactor);
    	//	mNode->setOrientation(sqrt(0.5),0.0,sqrt(0.5),0.0);
	//	}

	//if(mInputDevice->isKeyDown(Ogre::KC_DOWN))
        //	{
	//	mNode->translate(0.0, 0.0, MoveFactor);
     	//	mNode->setOrientation(sqrt(0.5),0.0,-sqrt(0.5),0.0);
	//	}
		
	//if(mInputDevice->isKeyDown(Ogre::KC_LEFT))
        //	{
	//	mNode->translate(-MoveFactor, 0.0, 0.0);
	//	mNode->setOrientation(0.0,0.0,1.0,0.0);		
    	//	}

	//if(mInputDevice->isKeyDown(Ogre::KC_RIGHT))
        //	{
	//	mNode->translate(MoveFactor, 0.0, 0.0);
	//	mNode->setOrientation(0.0,0.0,0.0,0.0);
	//	}
	//}
    //else
	//{
	//mAnimationState = mEntity->getAnimationState( "Idle" );
        //mAnimationState->setLoop( true );
        //mAnimationState->setEnabled( true );
	//}	
	

	return true;
}

bool PlayState::frameEnded(const FrameEvent& evt)
{
	//mAnimationState->addTime( evt.timeSinceLastFrame );



	return true;
}
